
#ifndef __CONFIG__
#define __CONFIG__

/* The next few lines are the only really system dependent stuff.
** They are max values for various types and epsilons for float comparison.
*/


/*
**	Things for configure to set.
*/
/* Describe how yytext is declared. */
#define YYTEXT_POINTER 1

/* Various max values (used as masks). */
#define SIZEOF_SHORT 2
#if ( SIZEOF_SHORT == 2 )
#define MAX_SIGNED_SHORT 0x7FFF
#define MAX_UNSIGNED_SHORT 0xFFFF
#else
#define MAX_SIGNED_SHORT 0x7FFFFFFF
#define MAX_UNSIGNED_SHORT 0xFFFFFFFF
#endif

/* Directory header file info. */
#define HAVE_DIRENT_H 1
#define HAVE_SYS_NDIR_H 0
#define HAVE_SYS_DIR_H 0
#define HAVE_NDIR_H 0

/* Strings header file info. */
#define HAVE_STRING_H 1
#define HAVE_STRINGS_H 1

/* Define a  machine EPSILON, used to compare floats to 0.	*/
#define EPSILON 1.e-13
#define SMALL_NUM 1.e-5

/* The max size of the text entry buffer. */
/* Make it bigger or smaller depending on memory, but 128 is enough. */
#define ENTRY_STRING_LENGTH 128

/* The default width for the rectangle used to select objects by a single
** click.
*/
#define SELECTION_CLICK_WIDTH 3

#endif
