
#include <stdio.h>
#include <string.h>

#define LINELEN 255
#define NEWLINE '\n'

typedef struct {
   float x,y,z;
} vertex;

typedef struct {
   int cnt;
   int facets[50];
} facet;

vertex *vertices;
facet  *facets;

int vertice_count, facet_count, edge_count;

int add_vertex(line)
char *line;
{
   if (!vertice_count)
      vertices=(vertex *)malloc(sizeof(vertex));
   else
      vertices=(vertex *)realloc(vertices,sizeof(vertex)*(vertice_count+1));

   sscanf(line,"v %f %f %f",&(vertices[vertice_count].x),
      &(vertices[vertice_count].y),&(vertices[vertice_count].z));

   return(++vertice_count);
}
#if( 0 ) 
int count_sides(line)
char *line;
{
   char *s;
   int count=0;

   s=strdup(line);

   strtok(s," "); /* skip 'f' type identifier */
   while (strtok(NULL," "))
      count++;

   free(s);

   return(count);
}
#endif
void parse_facet(line)
char *line;
{
   char *token;
   char *split;
   int vertice;
   int normal;
   int f = 0;

   if (!facet_count)
      facets=(facet *)malloc(sizeof(facet));
   else
      facets=(facet *)realloc(facets,sizeof(facet)*(facet_count+1));
/*
   int sides;

   sides=count_sides(line);

   if (sides==3)
      printf("triangle\n");
   else
      printf("poly\n");
*/
   strtok(line," "); /* skip 'f' type identifier */
   while (token=strtok(NULL," ")) {
      ++edge_count;
      ++(facets[facet_count].cnt);

      vertice=atoi(token);
      facets[facet_count].facets[f++] = vertice;
/*
      printf("%f %f %f",vertices[vertice].x,
         vertices[vertice].y,vertices[vertice].z);

      if (sides==3 && (split=strstr(token,"//")))
         {
         normal=atoi(split+2);
         printf(" %f %f %f",vnormals[normal].x,vnormals[normal].y,
            vnormals[normal].z);
         }

      printf("\n");
*/
   }
   ++facet_count;
}

static int strbpos( s, c )
char *s, c;
{
    int i = -1;
    int l = strlen( s );
    for( i=l-1; i>=0; i-- )
        if( s[i] == c )
            return i;
    return i;
}

main(argc, argv)
int   argc;
char *argv[];
{
  char *filename;
  int i, j;
  FILE *fp;
  char line[LINELEN+1];

  vertice_count = facet_count = edge_count = 0;

  while(--argc) {
      argv++;
      if(argv[0][0] != '-')
          break;
      switch(argv[0][1]) {
      case 'h':
      case 'H':
      default:
          fprintf(stderr,"Viewpoint OBJ to OFF translator\n");
          fprintf(stderr,"usage: obj2off OBJ-file\n");
          exit();
          break;
      }
  }

  if(argc > 1) {
      fprintf(stderr,"Viewpoint OBJ to OFF translator\n");
      fprintf(stderr,"usage: obj2off OBJ-file\n");
      exit(1);
  } else if(argc == 1)
      filename = argv[0];
  else
      filename = "stdin";

  if(strcmp(filename, "stdin") != 0) {
      if ((fp = fopen(filename, "r")) == NULL) {
          fprintf(stderr,"failed to open input file for reading");
          exit(1);
      }
  }
  else
      fp = stdin;

  while (fgets(line,LINELEN,fp)) {
    switch (*line) {

      case '#': /* comment */
      case '$': /* seems to be comment */
        /* convert_comment(line); */
        break;

      case 'v': /* vertex */
        switch (*(line+1)) {
          case ' ': /* regular vertex 'v' */
            add_vertex(line);
            break;

          case 'n': /* vertex normal 'vn' */
            /* add_vertex_normal(line); */
            break;

          default: /* unsupported vertex type */
            /* fprintf(stderr,"Unsupported vertex type: '%s'\n",line); */
            ;
        }
        break;

      case 'l': /* line */
        /* convert_line(line); */
        break;

      case 'g': /* group */
        /* convert_comment(line); */
        break;

      case 's': /* smoothing group # */
        /* convert_comment(line); */
        break;

      case 'f': /* facet */
        parse_facet(line);
        break;

      case (int)0: /* Empty line */
        /* printf("\n"); */
        break;

      default:
        /* fprintf(stderr,"Error: cannot handle: '%s'\n",line); */
        ;
    }
  }

  fclose(fp);

{
    FILE *fpaoff;
    char  aoff[255];
    int   pos;

    strcpy (aoff, filename);

    pos = strbpos (aoff, '.');
    aoff[pos+1] = 'a';
    aoff[pos+2] = 'o';
    aoff[pos+3] = 'f';
    aoff[pos+4] = 'f';
    aoff[pos+5] = '\0';
    fpaoff = fopen (aoff, "w");

    aoff[pos+1] = 'g';
    aoff[pos+2] = 'e';
    aoff[pos+3] = 'o';
    aoff[pos+4] = 'm';
    aoff[pos+5] = '\0';
    fprintf (fpaoff, "\n");
    fprintf (fpaoff, "geometry\t\tindexed_poly\tfff\t%s\n", aoff);
    fprintf (fpaoff, "connect_offset\tdefault\t\t\tf\t0\n\n");
    fclose  (fpaoff);
}

  fprintf(stdout,"%d %d %d\n", vertice_count, facet_count, edge_count);
  for( i=0; i<vertice_count; i++ )
  fprintf(stdout,"%f %f %f\n",vertices[i].x, vertices[i].y,vertices[i].z);
  for( i=0; i<facet_count; i++ ) {
    fprintf( stdout, "%d ", facets[i].cnt );
    for( j=0; j<facets[i].cnt; j++ )
      fprintf( stdout, "%d ", facets[i].facets[j] );
    fprintf(stdout,"\n");
  }
}
